// C Source File
// Created 04/01/2003; 18:09:49

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 200           // Compile for AMS 2.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "tiles.h"

BOOL LoadTiles(void);

char *filename = "tiles";     // The filename used to store the tiles
MULTI_EXPR *Data;
unsigned short TileCount;

// Main Function
void _main(void)
{
	unsigned char x, y, t;
	void *plane0, *plane1;
	
	if (!LoadTiles())
		return;
	randomize();
	if (!GrayOn())
		return;
	SetPlane(0);
	ClrScr();
	SetPlane(1);
	ClrScr();
	plane0 = GetPlane(0);
	plane1 = GetPlane(1);
	while (!kbhit())
	{
		if (TI89) {
			x = (unsigned char)ceil((float)rand() * (float)10 / (float)RAND_MAX) - 1;
			y = (unsigned char)ceil((float)rand() * (float)6 / (float)RAND_MAX) - 1;
		} else {
			x = (unsigned char)ceil((float)rand() * (float)15 / (float)RAND_MAX) - 1;
			y = (unsigned char)ceil((float)rand() * (float)8 / (float)RAND_MAX) - 1;
		}
		t = (unsigned char)ceil((float)rand() * (float)TileCount / (float)RAND_MAX) - 1;
		scr_set_tile16(plane0, (unsigned short *)&Data->Expr[2 + (t << 6)], x, y);
		scr_set_tile16(plane1, (unsigned short *)&Data->Expr[34 + (t << 6)], x, y);
	}
	GrayOff();
	GKeyFlush();
}

BOOL LoadTiles(void)
{
	if ((SymFindPtr(SYMSTR(filename), 0) == NULL))
		return FALSE;
	Data = HeapDeref(SymFindPtr(SYMSTR(filename), 0)->handle);
	if (Data->Size < 9)
		return FALSE;
	memcpy(&TileCount, &Data->Expr, 2);
	if (Data->Size < 9 + (TileCount << 6))
		return FALSE;
	return TRUE;
}